#!/usr/bin/env python

# author: Pocholo
# date: 6/24/20

# Comments directed to http://gimpchat.com

# It create a Christmas bauble with an option for a color or pattern

# Installation:
# This script should be placed in the user plugins folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.

from gimpfu import *

def pm_christmas_bauble(size, text, customtext, fontname, justify, linespa, 
                                                                 fontcolor, 
																colorLayer, 
																 ballColor, 
															  patternLayer, 
															   ballpattern, 
																 crowngrad):

	#Initiates the temporary state
	pdb.gimp_context_push()
	
	#Variables
	x = size/1000
		
	#Create background layer
	img = pdb.gimp_image_new(size, size, RGB)
	backLayer = pdb.gimp_layer_new(img, size, size, RGB, "Background", 100, LAYER_MODE_NORMAL)
	pdb.gimp_layer_add_alpha(backLayer)
	pdb.gimp_image_add_layer(img, backLayer, 0)
	pdb.gimp_context_set_foreground((255, 255, 255))
	pdb.gimp_drawable_fill(backLayer, FILL_FOREGROUND)
	
	pdb.gimp_display_new(img)
	
	#Create the ball layer 
	if colorLayer == True:		
		colorLayer = pdb.gimp_layer_new(img, size, size, RGB, "Christmas ball", 100, LAYER_MODE_NORMAL)
		pdb.gimp_layer_add_alpha(colorLayer)
		pdb.gimp_image_add_layer(img, colorLayer, 0)
		pdb.gimp_context_set_foreground(ballColor)
		pdb.gimp_drawable_fill(colorLayer, FILL_FOREGROUND)
	
		#using map to create the sphere shape
		pdb.plug_in_map_object(img, colorLayer, 
										   1,    # Type of mapping (0=plane,1=sphere,2=box,3=cylinder)
							   0.5, 0.5, 2.0,    # viewpoint
							   0.5, 0.5, 0.0,    # object pos
							   1.0, 0.0, 0.0,    # first axis
							   0.0, 1.0, 0.0,    # 2nd axis
							   0.0, 0.0, 0.0,    # axis rotation
										   0,    # Type of lightsource (0=point,1=directional,2=none)
							 (255, 255, 255),    # Lightsource color (r,g,b)
							 -0.5, -0.5, 2.0,    # light position
							 -1.0, -1.0, 1.0,    # light direction
				1.00, 0.60, 0.30, 1.50, 50.0,    # material (amb, diff, refl, spec, high)
										True,    # antialias
									   False,    # tile
									   False,    # new image
										True,    # transparency
										0.25,    # Sphere/cylinder radius (only used when maptype=1 or 3)
							   0.5, 0.5, 0.5,    # box size
										1.00,    # unused parameter Cylinder length
										None,    # Box front face (set these to -1 if not used)
										None,    # Box back face
										None,    # Box top face									
										None,    # Box bottom face
										None,    # Box left face
										None,    # Box right face
										None,    # Cylinder top face (unused parameter)
										None)    # Cylinder bottom face (unused parameter)
			
		
		#Create the text		
		tex = size/3
		pdb.gimp_context_set_foreground(fontcolor)
		textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 10, 1, tex, PIXELS, fontname)
		pdb.gimp_text_layer_set_justification(textLayer, justify)
		pdb.gimp_text_layer_set_line_spacing(textLayer, linespa)
		
		#Resize text
		pdb.gimp_layer_scale (textLayer, tex, tex, TRUE)
		
		
		#Making the text centered	
		textLayer = pdb.gimp_image_get_active_layer(img)
		pdb.gimp_image_set_active_layer(img, textLayer)
		wh = pdb.gimp_drawable_width(textLayer)
		hh = pdb.gimp_drawable_height(textLayer)
		w = pdb.gimp_image_width(img)
		h = pdb.gimp_image_height(img)
		pdb.gimp_image_set_active_layer(img,textLayer)
		centerx=w/2
		centery=h/2
		adw=wh/2
		adh=hh/2
		sw=centerx - adw
		sh=centery - adh		
		pdb.gimp_layer_set_offsets(textLayer, sw, sh)
		pdb.gimp_layer_resize_to_image_size(textLayer)
		
		#Create the Text distortion
		pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
		pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
		pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
		pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
		pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
		pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
		pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
		
		#Clean overlay
		pdb.gimp_image_select_item(img, 2, colorLayer)
		pdb.gimp_selection_invert(img)
		pdb.gimp_edit_clear(textLayer)
		pdb.gimp_selection_none(img)
		pdb.gimp_layer_set_mode(textLayer, LAYER_MODE_GRAIN_MERGE)
		non_empty = pdb.gimp_edit_copy(textLayer)
		textCopy = pdb.gimp_layer_new(img, size, size, RGB, "Text copy", 50, LAYER_MODE_GRAIN_MERGE)
		pdb.gimp_image_add_layer(img, textCopy, 0)
		pdb.gimp_layer_add_alpha(textCopy)
		pdb.gimp_drawable_fill(textCopy, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(textCopy, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)
				
		#Create light other reflections
		pdb.gimp_image_select_item(img, 2, colorLayer)
		refLayer = pdb.gimp_layer_new(img, size, size, RGB, "Light reflection", 100, LAYER_MODE_HSV_VALUE)
		pdb.gimp_layer_add_alpha(refLayer)
		pdb.gimp_image_add_layer(img, refLayer, 0)
		pdb.gimp_drawable_fill(refLayer, FILL_TRANSPARENT)
		pdb.gimp_context_set_foreground((255, 255, 255))
		pdb.gimp_context_set_brush("2. Hardness 075")
		pdb.gimp_context_set_brush_size(200*x)
		pdb.gimp_context_set_brush_aspect_ratio(0.50)
		pdb.gimp_context_set_brush_angle(-20)
		pdb.gimp_context_set_brush_default_spacing()
		pdb.gimp_paintbrush_default(refLayer, 2, [626*x, 544*x])
		pdb.gimp_context_set_brush_angle(-20)
		pdb.gimp_paintbrush_default(refLayer, 2, [430*x, 720*x])
		pdb.plug_in_gauss(img, refLayer, 50, 50, 1)
		pdb.gimp_selection_none(img)
				
		#Crown base
		baseLayer = pdb.gimp_layer_new(img, size, size, RGB, "Crown base", 100, LAYER_MODE_NORMAL)
		pdb.gimp_layer_add_alpha(baseLayer)
		pdb.gimp_image_add_layer(img, baseLayer, 0)
		pdb.gimp_drawable_fill(baseLayer, FILL_TRANSPARENT)
		pdb.gimp_image_select_round_rectangle(img, 2, 450*x, 214*x, 100*x, 50*x, 10*x, 10*x)
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_foreground(ballColor)
		pdb.gimp_drawable_edit_fill(baseLayer, FILL_FOREGROUND)
		pdb.gimp_selection_none(img)
	
		#Create the crown 
		crownLayer = pdb.gimp_layer_new(img, size, size, RGB, "Crown", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, crownLayer, 0)
		pdb.gimp_layer_add_alpha(crownLayer)
		pdb.gimp_drawable_fill(crownLayer, FILL_TRANSPARENT)
		pdb.gimp_image_select_round_rectangle(img, 2, 440*x, 197*x, 120*x, 60*x, 12*x, 12*x)
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_gradient(crowngrad)
		pdb.gimp_context_set_gradient_repeat_mode(0)
		pdb.gimp_context_set_gradient_reverse(TRUE)
		pdb.gimp_drawable_edit_gradient_fill(crownLayer, 0, 0, TRUE, 3, 0.20, TRUE, 434*x, 220*x, 565*x, 220*x)
		pdb.gimp_selection_none(img)
		
		#Create arches on the crown
		pdb.gimp_context_set_brush("2. Hardness 100")
		pdb.gimp_context_set_brush_size(47*x)
		pdb.gimp_context_set_brush_aspect_ratio(0)
		pdb.gimp_context_set_brush_angle(0)
		pdb.gimp_context_set_brush_hardness(1)
		pdb.gimp_context_set_brush_default_spacing()
		pdb.gimp_eraser_default(crownLayer, 2, [465*x, 271*x])
		pdb.gimp_eraser_default(crownLayer, 2, [500*x, 271*x])
		pdb.gimp_eraser_default(crownLayer, 2, [535*x, 271*x])
				
		#Create the crown metal ring 
		ringLayer = pdb.gimp_layer_new(img, size, size, RGB, "Ring", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, ringLayer, 2)
		pdb.gimp_layer_add_alpha(ringLayer)
		pdb.gimp_drawable_fill(ringLayer, FILL_TRANSPARENT)
		pdb.gimp_image_select_ellipse(img, 2, 459*x, 140*x, 80*x, 100*x)
		pdb.gimp_context_set_brush("2. Hardness 100")
		pdb.gimp_context_set_brush_size(5*x)
		pdb.gimp_context_set_brush_aspect_ratio(0)
		pdb.gimp_context_set_brush_angle(0)
		pdb.gimp_context_set_brush_spacing(0.01)
		pdb.gimp_context_set_paint_method("gimp-paintbrush")
		pdb.gimp_context_set_stroke_method(STROKE_PAINT_METHOD)
		pdb.gimp_context_set_foreground((0, 0, 0))
		pdb.gimp_drawable_edit_stroke_selection(ringLayer)
		pdb.gimp_selection_none(img)
				
		
	#Using pattern
	if patternLayer == True:
		patternLayer = pdb.gimp_layer_new(img, size, size, RGB, "Christmas ball", 100, LAYER_MODE_NORMAL)
		pdb.gimp_layer_add_alpha(patternLayer)
		pdb.gimp_image_add_layer(img, patternLayer, 0)
		pdb.gimp_context_set_pattern(ballpattern)
		pdb.gimp_drawable_fill(patternLayer, FILL_PATTERN)
	
		#using map to create the sphere shape
		pdb.plug_in_map_object(img, patternLayer, 
										   1,    # Type of mapping (0=plane,1=sphere,2=box,3=cylinder)
							   0.5, 0.5, 2.0,    # viewpoint
							   0.5, 0.5, 0.0,    # object pos
							   1.0, 0.0, 0.0,    # first axis
							   0.0, 1.0, 0.0,    # 2nd axis
							   0.0, 0.0, 0.0,    # axis rotation
										   0,    # Type of lightsource (0=point,1=directional,2=none)
							 (255, 255, 255),    # Lightsource color (r,g,b)
							 -0.5, -0.5, 2.0,    # light position
							 -1.0, -1.0, 1.0,    # light direction
				0.50, 0.80, 0.40, 0.20, 27.0,    # material (amb, diff, refl, spec, high)
										True,    # antialias
									   False,    # tile
									   False,    # new image
										True,    # transparency
										0.25,    # Sphere/cylinder radius (only used when maptype=1 or 3)
							   0.5, 0.5, 0.5,    # box size
										1.00,    # unused parameter Cylinder length
										None,    # Box front face (set these to -1 if not used)
										None,    # Box back face
										None,    # Box top face									
										None,    # Box bottom face
										None,    # Box left face
										None,    # Box right face
										None,    # Cylinder top face (unused parameter)
										None)    # Cylinder bottom face (unused parameter)
	

		if text == True:
			#Create the text		
			tex = size/3
			pdb.gimp_context_set_foreground(fontcolor)
			textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 10, 1, tex, PIXELS, fontname)
			pdb.gimp_text_layer_set_justification(textLayer, justify)
			pdb.gimp_text_layer_set_line_spacing(textLayer, linespa)
			
			#Resize text
			pdb.gimp_layer_scale (textLayer, tex, tex, TRUE)
			
			
			#Making the text centered	
			textLayer = pdb.gimp_image_get_active_layer(img)
			pdb.gimp_image_set_active_layer(img, textLayer)
			wh = pdb.gimp_drawable_width(textLayer)
			hh = pdb.gimp_drawable_height(textLayer)
			w = pdb.gimp_image_width(img)
			h = pdb.gimp_image_height(img)
			pdb.gimp_image_set_active_layer(img,textLayer)
			centerx=w/2
			centery=h/2
			adw=wh/2
			adh=hh/2
			sw=centerx - adw
			sh=centery - adh		
			pdb.gimp_layer_set_offsets(textLayer, sw, sh)
			pdb.gimp_layer_resize_to_image_size(textLayer)
			
			#Create the Text distortion
			pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
			pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
			pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
			pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
			pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
			pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
			pdb.plug_in_lens_distortion(img, textLayer, 0, 0, 100, 0, 10*x, 0)
			
			#Clean overlay
			pdb.gimp_image_select_item(img, 2, patternLayer)
			pdb.gimp_selection_invert(img)
			pdb.gimp_edit_clear(textLayer)
			pdb.gimp_selection_none(img)
			pdb.gimp_layer_set_mode(textLayer, LAYER_MODE_GRAIN_MERGE)
			non_empty = pdb.gimp_edit_copy(textLayer)
			textCopy = pdb.gimp_layer_new(img, size, size, RGB, "Text copy", 50, LAYER_MODE_GRAIN_MERGE)
			pdb.gimp_image_add_layer(img, textCopy, 0)
			pdb.gimp_layer_add_alpha(textCopy)
			pdb.gimp_drawable_fill(textCopy, FILL_TRANSPARENT)
			floating_sel = pdb.gimp_edit_paste(textCopy, FALSE)
			pdb.gimp_floating_sel_anchor(floating_sel)
		
						
		#Crown base
		baseLayer = pdb.gimp_layer_new(img, size, size, RGB, "Crown base", 100, LAYER_MODE_NORMAL)
		pdb.gimp_layer_add_alpha(baseLayer)
		pdb.gimp_image_add_layer(img, baseLayer, 0)
		pdb.gimp_drawable_fill(baseLayer, FILL_TRANSPARENT)
		pdb.gimp_image_select_round_rectangle(img, 2, 450*x, 214*x, 100*x, 50*x, 10*x, 10*x)
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_pattern(ballpattern)
		pdb.gimp_edit_bucket_fill(baseLayer, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
		pdb.gimp_selection_none(img)
	
		#Create the crown 
		crownLayer = pdb.gimp_layer_new(img, size, size, RGB, "Crown", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, crownLayer, 0)
		pdb.gimp_layer_add_alpha(crownLayer)
		pdb.gimp_drawable_fill(crownLayer, FILL_TRANSPARENT)
		pdb.gimp_image_select_round_rectangle(img, 2, 440*x, 197*x, 120*x, 60*x, 12*x, 12*x)
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_gradient(crowngrad)
		pdb.gimp_context_set_gradient_repeat_mode(0)
		pdb.gimp_context_set_gradient_reverse(TRUE)
		pdb.gimp_drawable_edit_gradient_fill(crownLayer, 0, 0, TRUE, 3, 0.20, TRUE, 434*x, 220*x, 565*x, 220*x)
		pdb.gimp_selection_none(img)
		
		#Create arches on the crown
		pdb.gimp_context_set_brush("2. Hardness 100")
		pdb.gimp_context_set_brush_size(47*x)
		pdb.gimp_context_set_brush_aspect_ratio(0)
		pdb.gimp_context_set_brush_angle(0)
		pdb.gimp_context_set_brush_hardness(1)
		pdb.gimp_context_set_brush_default_spacing()
		pdb.gimp_eraser_default(crownLayer, 2, [465*x, 271*x])
		pdb.gimp_eraser_default(crownLayer, 2, [500*x, 271*x])
		pdb.gimp_eraser_default(crownLayer, 2, [535*x, 271*x])
				
		#Create the crown metal ring 
		ringLayer = pdb.gimp_layer_new(img, size, size, RGB, "Ring", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, ringLayer, 2)
		pdb.gimp_layer_add_alpha(ringLayer)
		pdb.gimp_drawable_fill(ringLayer, FILL_TRANSPARENT)
		pdb.gimp_image_select_ellipse(img, 2, 459*x, 140*x, 80*x, 100*x)
		pdb.gimp_context_set_brush("2. Hardness 100")
		pdb.gimp_context_set_brush_size(5*x)
		pdb.gimp_context_set_brush_aspect_ratio(0)
		pdb.gimp_context_set_brush_angle(0)
		pdb.gimp_context_set_brush_spacing(0.01)
		pdb.gimp_context_set_paint_method("gimp-paintbrush")
		pdb.gimp_context_set_stroke_method(STROKE_PAINT_METHOD)
		pdb.gimp_context_set_foreground((0, 0, 0))
		pdb.gimp_drawable_edit_stroke_selection(ringLayer)
		pdb.gimp_selection_none(img)
		
	#Resets the previous user defaults
	pdb.gimp_context_pop()
		
register(
	"pm_christmas_bauble",
	"Creates a Christmas ball",
	"Creates a Christmas ball",
	"Pocholo",
	"Pocholo",
	"2020",
	"Christmas bauble",
	"",
[	
	(PF_SPINNER, "size", "Ball size", 1000, (1, 2000, 1)),
	(PF_TOGGLE, "text", "Text with pattern?", False),
	(PF_TEXT, "customtext", "Text string", 'Merry\nChristmas'),
	(PF_FONT, "fontname", "Font name", "Merry Christmas Flake"),
	(PF_OPTION, "justify", "Justify", 2, ("Left", "Right", "Centered", "Fill")),
	(PF_ADJUSTMENT, "linespa", "Line spacing", 0, (-100, 100, 1)),
	(PF_COLOR, "fontcolor", "Font color", (255, 255, 255)),
	(PF_TOGGLE, "colorLayer", "Color?", False),
	(PF_COLOR, "ballcolor", "Color", (200, 0, 0)),
	(PF_TOGGLE, "patternLayer", "pattern?", False),
	(PF_PATTERN, "ballpattern", "Ball pattern", "Blue Web"),
	(PF_GRADIENT, "crowngrad", "Crown gradient", "Golden"),
],
[],
pm_christmas_bauble, menu="<Image>/Pocholo-scripts/Christmas bauble")
main()			